
#ifndef CMC_H__
#define CMC_H__

#include <xcmc.h>
#include <xcmcext.h>
#include <xcmcmsxt.h>

BOOL CMCInitialize();
VOID CMCUninitialize();

CMC_return_code CMCActOn( CMC_session_id session, 
                          CMC_message_reference* message_reference, 
                          CMC_enum operation, 
                          CMC_flags act_on_flags, 
                          CMC_ui_id ui_id, 
                          CMC_extension* act_on_extensions );

CMC_return_code CMCFree( CMC_buffer memory );

CMC_return_code CMCList( CMC_session_id session, 
                         CMC_string message_type, 
                         CMC_flags list_flags, 
                         CMC_message_reference* seed, 
                         CMC_uint32* count, 
                         CMC_ui_id ui_id, 
                         CMC_message_summary** result, 
                         CMC_extension* list_extensions );

CMC_return_code CMCLogoff( CMC_session_id session, 
                           CMC_ui_id ui_id, 
                           CMC_flags logoff_flags, 
                           CMC_extension* logoff_extensions );

CMC_return_code CMCLogon( CMC_string service, 
                          CMC_string user, 
                          CMC_string password, 
                          CMC_object_identifier character_set, 
                          CMC_ui_id ui_id, 
                          CMC_uint16 caller_CMC_version, 
                          CMC_flags logon_flags, 
                          CMC_session_id* session, 
                          CMC_extension* logon_extensions );

CMC_return_code CMCLookup( CMC_session_id session, 
                           CMC_recipient* recipient_in, 
                           CMC_flags look_up_flags, 
                           CMC_ui_id ui_id, 
                           CMC_uint32* count, 
                           CMC_recipient** recipient_out, 
                           CMC_extension* look_up_extensions );

CMC_return_code CMCQueryConfiguration( CMC_session_id session, 
                                       CMC_enum item, 
                                       CMC_buffer reference, 
                                       CMC_extension* config_extensions );

CMC_return_code CMCRead( CMC_session_id session, 
                         CMC_message_reference* message_reference, 
                         CMC_flags read_flags, 
                         CMC_message** message, 
                         CMC_ui_id ui_id, 
                         CMC_extension* read_extensions );

CMC_return_code CMCSend( CMC_session_id session, 
                         CMC_message* message, 
                         CMC_flags send_flags, 
                         CMC_ui_id ui_id, 
                         CMC_extension* send_extensions );

CMC_return_code CMCSendDocuments( CMC_string recipient_addresses, 
                                  CMC_string subject, 
                                  CMC_string text_note, 
                                  CMC_flags send_doc_flags, 
                                  CMC_string file_paths, 
                                  CMC_string file_names, 
                                  CMC_string delimiter, 
                                  CMC_ui_id ui_id );

#endif
